from datetime import datetime

from atproto import models


class Client:
    app:    AppNamespace

    def get_current_time_iso (self) -> datetime: ...

    def get_post_thread (
            self,
            uri:            str,
            parent_height:  int | None  = None
    ) -> Response: ...

    def follow (self, did: str) -> None: ...


class AppNamespace:
    bsky:   AppBskyNamespace


class AppBskyNamespace:
    notification:   AppBskyNotificationNamespace


class AppBskyNotificationNamespace:
    def list_notifications (self) -> Response: ...

    def update_seen (self, seen: dict[str, datetime]) -> None: ...


class Response:
    notifications:  list[Notification]
    thread:         (ThreadViewPost
                     | models.AppBskyFeedDefs.NotFoundPost
                     | models.AppBskyFeedDefs.BlockedPost)


class Notification:
    is_read:    bool
    reason:     str
    uri:        str
    author:     ProfileView


class ProfileView:
    did:    str
